'import the messaging namespace for easier syntax
Imports System.Messaging

Public Class staticExamples

  Public Shared Function CreateQueue( _
      ByVal queuePath As String) As Boolean

    'purpose: create a new queue based on a given path
    '         returns true if queue created, else false

    'instantiate a static (has no queue reference) queue object
    Dim queue As New MessageQueue()

    'verify the queue doesn't already exist prior to creation
    If Not queue.Exists(path:=queuePath) Then

      Try

        'create the queue
        queue.Create(path:=queuePath)

        Return True

      Catch

        Return False

      End Try

    Else
      'raise a message that queue already exists ...
    End If

  End Function

  Public Shared Function DeleteQueue( _
      ByVal queuePath As String) As Boolean

    'purpose: delete a queue based on a given path
    '         returns true if queue deleted, else false

    'instantiate a static (has no queue reference) queue object
    Dim queue As New MessageQueue()

    'verify queue exists prior to deleting
    If queue.Exists(path:=queuePath) Then

      Try

        'delete the queue
        queue.Delete(path:=queuePath)

        Return True

      Catch

        Return False

      End Try

    Else
      'could raise a message that there is no queue to delete
    End If

  End Function

End Class

Module Module1

  Sub main()

    'purpose: call the function(s) & write the result to the console

    Console.WriteLine( _
        staticExamples.CreateQueue(".\Private$\TestQueue"))

    Console.WriteLine( _
        staticExamples.DeleteQueue(".\Private$\TestQueue"))

    'wait for the user to stop the console application
    'this allows you to view the results
    Console.WriteLine("Enter 's' to stop the application.")

    'loop until users presses s key
    Do While Console.ReadLine <> "s" : Loop

  End Sub

End Module