Imports System.Messaging

Module Module1

    Sub Main()

        'purpose:   demonstrate binary formatter
        '           application opens a bitmap file, streams the contents
        '             to a message. The message is then received from the
        '             queue where it is stream back out into a new file

        'local scope
        Dim fileStream As IO.FileStream
        Dim queue As MessageQueue = _
            New MessageQueue(path:=".\Private$\myqueue")
        Dim msg As New Message()
        Dim fileByte As Integer

        'tell the formatter object to use the binary formatter
        msg.Formatter = New BinaryMessageFormatter()

        'set the stream location to the start
        msg.BodyStream.Seek(offset:=0, _
            origin:=IO.SeekOrigin.Begin)

        'create new fileStream object based on a bitmap file
        fileStream = New IO.FileStream(path:="c:\figure 11-1.bmp", _
            mode:=IO.FileMode.Open, access:=IO.FileAccess.Read)

        'read the contents of the file and write to the message as bytes
        fileByte = fileStream.ReadByte()
        Do While fileByte <> -1
            msg.BodyStream.WriteByte(value:=fileByte)
            fileByte = fileStream.ReadByte()
        Loop
        fileStream.Close()

        'purge the queue
        queue.Purge()

        'send the message to the queue
        queue.Send(obj:=msg)

        '----allows you to check the message
        'wait for you to continue the app. 
        Console.WriteLine("Message Sent.")
        Console.WriteLine("Enter 'c' to continue the application.")
        Do While Console.ReadLine <> "c" : Loop

        'receive the message
        msg = queue.Receive()

        'create a new fileStream object and file
        fileStream = New IO.FileStream(path:="c:\figure 11-1-2.bmp", _
            mode:=IO.FileMode.Create, access:=IO.FileAccess.Write)

        'set the stream location to the start
        msg.BodyStream.Seek(offset:=0, _
            origin:=IO.SeekOrigin.Begin)

        'read the contents of the message and write to the new file
        fileByte = msg.BodyStream.ReadByte()
        Do While fileByte <> -1
            fileStream.WriteByte(value:=fileByte)
            fileByte = msg.BodyStream.ReadByte()
        Loop
        fileStream.Close()

    End Sub

End Module
