Imports System.Messaging

Module Module1

  Sub Main()

    'purpose: transaction sending example

    'local scope
    Dim queue As New MessageQueue(path:=".\private$\myQueue")
    Dim trx As New MessageQueueTransaction()
    Dim cnt As Short
    Dim msg() As Message

    'make sure the queue is transactional
    If Not (queue.Transactional) Then
      MsgBox(Prompt:="Please mark queue as transactional")
      End
    End If

    'purge the queue
    queue.Purge()

    'begin the transaction
    Console.WriteLine("Trx Status: " & trx.Status.ToString)
    trx.Begin()
    Console.WriteLine("Trx Status: " & trx.Status.ToString)

    'send a couple messages
    For cnt = 1 To 4
      'send the message and pass the transaction 
      '  context on the function signature
      queue.Send(obj:="Trx Example " & cnt, transaction:=trx)
    Next

    'check the queue for messages
    msg = queue.GetAllMessages
    Console.WriteLine("Messages prior to commit: " & UBound(msg) + 1)

    ''commit the transaction
    trx.Commit()
    Console.WriteLine("Trx Status: " & trx.Status.ToString)

    'check the queue again for messages
    msg = queue.GetAllMessages
    Console.WriteLine("Messages after to commit: " & UBound(msg) + 1)

    'pause the app. to read the console
    Console.WriteLine("Press 's' to stop the application")
    Do While Console.ReadLine <> "s" : Loop

  End Sub

End Module
