Imports System.Messaging

Module Module1

  Sub Main()

    'purpose: transaction sending example

    'local scope
    Dim queue As New MessageQueue(path:=".\private$\myqueue7")
    Dim trxSend As New MessageQueueTransaction()
    Dim trxRec As New MessageQueueTransaction()
    Dim cnt As Short
    Dim msg(4) As Message

    'make sure the queue is transactional
    If Not (queue.Transactional) Then
      MsgBox(prompt:="Please mark queue as transactional") : End
    End If

    'purge the queue
    queue.Purge()

    'begin the send transaction
    trxSend.Begin()

    'send a couple messages
    For cnt = 1 To 4

      'send the message and pass the transaction 
      '  context on the function signature
      queue.Send(obj:="Transaction test " & cnt, _
          transaction:=trxSend)

      If cnt = 2 Then

        'send a non-transactional message in the sequence
        queue.Send(obj:="Non-Transactional")

      End If

    Next

    'commit the transaction
    trxSend.Commit()

    '----Receive transaction------

    'begin the receive transaction
    trxRec.Begin()

    'set the queue's formatter to xml
    queue.Formatter = New XmlMessageFormatter( _
        targetTypeNames:=New String() {"System.String"})

    'tell the queue to read all message properties
    queue.MessageReadPropertyFilter.SetAll()

    'receive the messages
    'note: the messages are not actually received until we call commit
    For cnt = 0 To 3
      msg(cnt) = queue.Receive(transaction:=trxRec)
    Next

    'commit the receive
    trxRec.Commit()

    'loop through the messages and display the results
    For cnt = 0 To 3

      'write the message's trx id
      Console.WriteLine("TransactionId: " & msg(cnt).TransactionId)

      'indicate if the message is the first in a transaction
      Console.WriteLine("Is First: " & _
          msg(cnt).IsFirstInTransaction)

      'indicate if the message is the last in a transaction
      Console.WriteLine("Is Last: " & _
          msg(cnt).IsLastInTransaction)

      'write the message body
      Console.WriteLine("Receive " & cnt & " Body: " _
          & msg(cnt).Body)

      'add some space between messages
      Console.WriteLine()
    Next

    'pause the app. to read the console
    Console.WriteLine("Press 's' to stop the application")
    Do While Console.ReadLine <> "s" : Loop

  End Sub

End Module
