Imports System.Messaging

Public Class qExplore
    Inherits System.Web.UI.Page
    Protected WithEvents userMsg As System.Web.UI.HtmlControls.HtmlGenericControl

    'form-level scope
    Private machineName As String
    Protected WithEvents queueList As System.Web.UI.HtmlControls.HtmlGenericControl
    Private isPublic As Boolean
    Private qPath As String
    Private showMsg As String
    Private showJournal As String
    Protected WithEvents qDetails As System.Web.UI.HtmlControls.HtmlGenericControl
    Private showProps As String

    Private Enum msgProcessing
        accept = 1
        reject = 2
    End Enum

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Init

        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.

        InitializeComponent()

    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        'purpose: init the page, control flow

        'check if the user is submitting the form (post) or requesting the page (get)
        If Request.ServerVariables("REQUEST_METHOD") = "GET" Then

            'return q-string values
            machineName = Request.QueryString(name:="machine")
            isPublic = Request.QueryString(name:="isPublic")
            qPath = Request.QueryString(name:="queueName")
            showMsg = Request.QueryString(name:="msgs")
            showJournal = Request.QueryString(name:="jrnl")
            showProps = Request.QueryString(name:="props")

            'display the q-information
            Call displayQueueInfo()

            'check if user has selected to view messages, 
            '  properties, or journal of a given queue
            If qPath <> "" Then

                If showProps = "True" Then
                    Call displayQueueProperties()

                ElseIf showMsg = "True" Then
                    Call displayQueueMessages()

                ElseIf showJournal = "True" Then
                    Call displayQueueJournal()

                End If
            Else
                qDetails.InnerHtml = ""
            End If

        Else

            'set machine and qPath based on hidden values
            machineName = Request.Form("machineName")
            qPath = Request.Form("qPath")
            isPublic = Request.Form("isPublic")

            'determine the button the user clicked
            Select Case Request.Form("subMsg")

                Case "Accept"

                    'receive messages that are checked
                    Call processMessages(msgProcessing.accept)

                Case "Reject"

                    'receive messages that are checked
                    Call processMessages(msgProcessing.reject)

            End Select

            Call displayQueueMessages()

        End If

    End Sub

    Private Sub processMessages(ByVal processType As msgProcessing)

        'purpose:   process messages based on type (accept or reject)

        'local scope
        Dim messageIds() As String
        Dim i As Int16
        Dim trx As New CTrx(machineName:=machineName, qPath:=qPath)

        Try
            'get messages to process
            Select Case processType

                Case msgProcessing.accept

                    'get an array of message ids to process
                    messageIds = Request.Form("accept").Split

                    'loop through each message
                    For i = 0 To UBound(messageIds)

                        'determine if message is transactional
                        If Request.Form(messageIds(i)) <> "" Then

                            'call receiveTrxMsg
                            trx.receiveTrxMsg(trxId:=Request.Form(messageIds(i)))

                        Else

                            'call receiveMsg
                            trx.receiveMsg(msgId:=messageIds(i))

                        End If
                    Next

                Case msgProcessing.reject

                    'get an array of message ids to process
                    messageIds = Request.Form("reject").Split

                    'loop through each message
                    For i = 0 To UBound(messageIds)

                        'determine if message is transactional
                        If Request.Form(messageIds(i)) <> "" Then

                            'call rejectTrxMsg
                            trx.rejectTrxMsg(trxId:=Request.Form(messageIds(i)))

                        Else

                            'call rejectMsg
                            trx.rejectMsg(msgId:=messageIds(i))

                        End If

                    Next

            End Select
        Catch

            'write out error information
            userMsg.InnerHtml = Err.Description

        End Try

    End Sub

    Private Sub displayQueueInfo()

        'purpose: show queue information 

        'local scope
        Dim explore As CExplore
        Dim queues() As MessageQueue
        Dim i As Int16
        Dim display As String

        'create a new instance of the explore class
        explore = New CExplore(machineName:=machineName)

        Try

            'return queue information
            queues = explore.returnQueues(isPublic:=CBool(isPublic))

        Catch

            'error getting queue information
            userMsg.InnerHtml = Err.Description
            Exit Sub

        End Try

        'display queue information
        display = "<table border=0 cellpadding=1 cellspacing=0>"
        display = display & "<tr><td class=tableTitle>Message Queues</td></tr>"

        'loop queues and write out to text string
        For i = 0 To UBound(array:=queues)

            'write the name of the queue
            display = display & "<tr><td class=queueCell>"
            display = display & queues(i).QueueName

            'write the properties link
            display = display & "<br>&nbsp;&nbsp;&nbsp;<a href=qExplore.aspx?"
            display = display & "queueName=" & queues(i).QueueName & "&props=True"
            display = display & "&msgs=False&jrnl=False&machine=" & machineName
            display = display & "&isPublic=" & CStr(isPublic) & ">Properties ...</a>"

            'write the messages link
            display = display & "<br>&nbsp;&nbsp;&nbsp;<a href=qExplore.aspx?"
            display = display & "queueName=" & queues(i).QueueName & "&props=False"
            display = display & "&msgs=True&jrnl=False&machine=" & machineName
            display = display & "&isPublic=" & CStr(isPublic) & ">Messages ...</a>"

            'write the journal link
            display = display & "<br>&nbsp;&nbsp;&nbsp;<a href=qExplore.aspx?"
            display = display & "queueName=" & queues(i).QueueName
            display = display & "&props=False&msgs=False&jrnl=True&machine="
            display = display & machineName & "&isPublic=" & CStr(isPublic)
            display = display & ">Journal ...</a>"

            'close the row
            display = display & "<br>&nbsp;</td></tr>"

        Next
        display = display & "</table>"

        'write display contents to the label control
        queueList.InnerHtml = display

    End Sub

    Private Sub displayQueueProperties()

        'purpose: update propery information for the given queue

        'local scope
        Dim display As String
        Dim mq As MessageQueue

        'create a new instance of the explore class
        Dim explore As New CExplore(machineName:=machineName)

        Try

            'return selected queue information
            mq = explore.returnQueue(qPath:=qPath)

        Catch

            'error getting queue information
            userMsg.InnerHtml = Err.Description
            Exit Sub

        End Try

        'show q properties
        display = "<table border=0 cellpadding=1 cellspacing=0 width=100%>"

        display = display & "<tr><td class=tableTitle colspan=2>Queues Properties: "
        display = display & qPath & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Format Name: "
        display = display & "</td><td class=queueCell>" & mq.FormatName & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Id: "
        display = display & "</td><td class=queueCell>" & mq.Id.ToString & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Category: "
        display = display & "</td><td class=queueCell>" & mq.Category.ToString
        display = display & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Can read: "
        display = display & "</td><td class=queueCell>" & mq.CanRead & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Can write: "
        display = display & "</td><td class=queueCell>" & mq.CanWrite & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Requires encryption: "
        display = display & "</td><td class=queueCell>" '
        display = display & mq.EncryptionRequired.ToString & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Authenticate: "
        display = display & "</td><td class=queueCell>" & mq.Authenticate.ToString
        display = display & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Label: "
        display = display & "</td><td class=queueCell>" & mq.Label & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Maximum size: "
        display = display & "</td><td class=queueCell>" & mq.MaximumQueueSize
        display = display & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Transactional: "
        display = display & "</td><td class=queueCell>" & mq.Transactional
        display = display & "</td></tr>"

        display = display & "<tr><td class=queueCell>" & "Uses Journal Queue: "
        display = display & "</td><td class=queueCell>" & mq.UseJournalQueue
        display = display & "</td></tr>"

        display = display & "</table>"

        qDetails.InnerHtml = display

    End Sub

    Private Sub displayQueueMessages()

        'purpose: update message list for the given queue

        'local scope
        Dim display As String
        Dim mq As MessageQueue
        Dim msg() As Message
        Dim i As Int16
        Dim trxPos As String

        'create a new instance of the explore class
        Dim explore As New CExplore(machineName:=machineName)

        Try

            'return all messages for the given queue
            msg = explore.returnMessages(qPath:=qPath)

            'get the queue information to determine trx level
            mq = explore.returnQueue(qPath:=qPath)

        Catch

            'display error if any
            userMsg.InnerHtml = Err.Description
            Exit Sub

        End Try

        'set hidden values (machine name, qPath, and public/private)
        display = display & "<input type=hidden name=machineName "
        display = display & "value=" & machineName & ">"
        display = display & "<input type=hidden name=qPath value= " & qPath & ">"
        display = display & "<input type=hidden name=isPublic value= " & isPublic & ">"

        'display message detail headings
        display = display & "<table border=0 cellpadding=1 cellspacing=0 width=100%>"

        display = display & "<tr><td class=tableTitle colspan=10>"
        display = display & "Queues Messages: " & qPath & "</td></tr>"

        display = display & "<tr><td class=colTitle>Sent</td>"
        'display = display & "<td class=colTitle>Label</td>"
        display = display & "<td class=colTitle>Priority</td>"
        display = display & "<td class=colTitle>Body</td>"

        'add trx col if transactional
        If mq.Transactional Then display = display & "<td class=colTitle>Trx</td>"

        'check for messages to decide if buttons should show
        If UBound(msg) >= 0 Then

            'add accept and reject buttons
            display = display & "<td class=colTitle align=center>"
            display = display & "<input type=submit value=Accept class=bttn name=subMsg>"
            display = display & "</td>"

            display = display & "<td class=colTitle align=center>"
            display = display & "<input type=submit value=Reject class=bttn name=subMsg>"
            display = display & "</td>"

        End If

        'close row
        display = display & "</tr>"

        'determine if messages exist
        If UBound(msg) >= 0 Then

            'loop messages and display        
            For i = 0 To UBound(msg)

                'indicate transactional information through colors
                If mq.Transactional Then

                    'check if the message is the first in the trx.
                    If msg(i).IsFirstInTransaction Then

                        'note: all messages sent to a trx. queue have a transaction id 
                        '      and we therefore assume transactional
                        '      also, messages that are both first and last in trx are
                        '      single message trx. we set them to first-level
                        display = display & "<tr class=trxFirst>"
                        trxPos = "First"

                    ElseIf msg(i).IsLastInTransaction And _
                        Not msg(i).IsFirstInTransaction Then

                        'messages last in the trx and not also first 
                        ' (single trx. message)
                        display = display & "<tr class=trxLast>"
                        trxPos = "Last"

                    Else

                        'messages in middle of trx
                        display = display & "<tr class=queueCell>"
                        trxPos = "Middle"

                    End If

                Else

                    'non-trx queue
                    display = display & "<tr class=queueCell>"

                End If

                'list message details: sent time link
                display = display & "<td><a href=qMessage.aspx?id="
                display = display & msg(i).Id & "&queueName=" & mq.QueueName
                display = display & "&machine=" & machineName & ">"
                display = display & msg(i).SentTime & "</a></td>"

                'display = display & "<td>" & msg(i).Label & "</td>"
                display = display & "<td>" & msg(i).Priority.ToString & "</td>"

                'transalte body if possible (only reads XML, string messages)
                Try

                    'add msg body to display string
                    display = display & "<td>" & msg(i).Body & "</td>"

                Catch

                    'cannot translate msg body
                    display = display & "<tr class=queueCell><td>Body:</td>"
                    display = display & "<td>--NOT XML STRING--</td></tr>"
                    Err.Clear()

                End Try

                'check if queue is transactional to display checkboxes
                If mq.Transactional Then

                    'indicate the msg's position in the trx
                    display = display & "<td>" & trxPos & "</td>"

                    'allow user to only accept or reject trx as a group
                    If trxPos = "First" Then

                        'show accept checkbox
                        display = display & "<td align=center><input type=checkbox "
                        display = display & "name=accept value=" & msg(i).Id & "></td>"

                        'show reject checkbox
                        display = display & "<td align=center><input type=checkbox "
                        display = display & "name=reject value=" & msg(i).Id & "></td>"

                        'add hidden value to indicate to post that this is 
                        '  part of a transaction
                        display = display & "<input type=hidden name=" & msg(i).Id
                        display = display & " value=" & msg(i).TransactionId & ">"

                    Else

                        'no check boxes
                        display = display & "<td>&nbsp;</td><td>&nbsp;</td>"

                    End If

                Else

                    'queue is not transactional (checkboxes for each message)

                    'show accept checkbox
                    display = display & "<td align=center><input type=checkbox "
                    display = display & "name=accept value=" & msg(i).Id & "></td>"

                    'show reject checkbox
                    display = display & "<td align=center><input type=checkbox "
                    display = display & "name=reject value=" & msg(i).Id & "></td>"

                End If

                'close the row
                display = display & "</tr>"

            Next
        Else

            'no messages in the queue
            display = display & "<tr class=queueCell><td colspan=10>"
            display = display & "There are no messages in the queue.</td></tr>"

        End If

        'close the table
        display = display & "</table>"

        'write the table to the label (div) control
        qDetails.InnerHtml = display

    End Sub

    Private Sub displayQueueJournal()

        'purpose: display journal information for the given queue

        'local scope
        Dim display As String
        Dim mq As MessageQueue
        Dim msg() As Message
        Dim i As Int16
        Dim trxPos As String

        'create a new instance of the explore class
        Dim explore As New CExplore(machineName:=machineName)

        'append journal to the path
        qPath = qPath & "\journal$"

        Try

            'return selected queue information
            msg = explore.returnMessages(qPath:=qPath)

            'get queue information to pass on q-string
            mq = explore.returnQueue(qPath:=qPath)

        Catch

            'error getting queue information
            userMsg.InnerHtml = Err.Description
            Exit Sub

        End Try

        'display messages
        display = "<table border=0 cellpadding=1 cellspacing=0 width=100%>"
        display = display & "<tr><td class=tableTitle colspan=4>"
        display = display & "Queues Messages: " & qPath & "</td></tr>"
        display = display & "<tr><td class=colTitle>Sent</td>"
        display = display & "<td class=colTitle>Label</td></tr>"

        'detmine if messages exist
        If UBound(msg) >= 0 Then

            'loop messages and display
            For i = 0 To UBound(msg)

                display = display & "<tr class=queueCell><td>"
                display = display & "<a href=qMessage.aspx?id=" & msg(i).Id
                display = display & "&queueName=" & mq.QueueName
                display = display & "&machine=" & machineName & ">"
                display = display & msg(i).SentTime & "</a></td>"
                display = display & "<td>" & msg(i).Label & "</td></tr>"

            Next

        Else

            'no messages in queue
            display = display & "<tr class=queueCell><td colspan=10>"
            display = display & "There are no messages in the queue.</td></tr>"

        End If

        'close the table
        display = display & "</table>"

        'write the table to the label (div) control
        qDetails.InnerHtml = display

    End Sub

End Class
