Imports System.Messaging

Public Class sendExample

  Public Shared Sub sendMessage( _
      ByVal queuePath As String, _
      ByVal msg As Object, _
      ByVal msgLabel As String)

    'purpose:   send a message to a queue

    'local scope
    Dim queue As New MessageQueue()

    'check to see if the queue exists
    If queue.Exists(path:=queuePath) Then

      'reference the physical queue
      queue.Path = queuePath

      'send the message to the queue
      queue.Send(obj:=msg, Label:=msgLabel)

    Else
      'raise some exception
    End If

  End Sub

End Class

Module Module1

  Sub main()

    'purpose: call the function(s) & write the result to the console

    'send a message
    'note: the dot (.) in the path is a shortcut to indicate you are 
    '      referencing the same server on which the code is executing
    sendExample.sendMessage( _
      queuePath:=".\Private$\myqueue", msg:="This is a test", _
      msgLabel:="TEST MESSAGE")

    'wait for the user to stop the console application
    'this allows you to view the results
    Console.WriteLine("Enter 's' to stop the application.")

    'loop until users presses s key
    Do While Console.ReadLine <> "s" : Loop

  End Sub

End Module
