Imports System.Messaging

Module Module1

    Sub Main()

        'purpose:   demonstrate the message timeout features

        'local scope
        Dim msg As New Message()
        Dim queue As MessageQueue = _
            New MessageQueue(path:=".\Private$\myqueue")
        Dim deadQueue As MessageQueue = _
            New MessageQueue(path:=".\Deadletter$")

        'purge both queues
        queue.Purge()
        Try
            deadQueue.Purge()
        Catch
            MsgBox(Err.Description)
        End Try

        'tell the message to use the dead letter queue
        msg.UseDeadLetterQueue = True

        'set the expiration using a TimeSpan instance
        msg.TimeToBeReceived = _
            New TimeSpan(hours:=0, minutes:=0, seconds:=15)

        'set the message body
        msg.Body = "Expiring message test"

        'send the message
        queue.Send(obj:=msg)

        'indicate we are watching the dead-letter queue
        Console.WriteLine("Message sent. Waiting ...")

        'grab message from dead letter queue (blocks until there)
        Try
            Console.WriteLine(deadQueue.Receive().Body)
        Catch
            MsgBox(Err.Description)
        End Try

        'wait to continue
        Console.WriteLine("Enter 's' to stop")
        Do While Not Console.ReadLine = "s" : Loop

    End Sub

End Module
