Imports system.Messaging

Module Module1

    Sub Main()

        'purpose:   demonstrate the acknow. and response 
        '           properties of the Message class

        'local scope
        Dim msg As New Message()
        Dim queue As New MessageQueue(path:=".\private$\myQueue")
        Dim ackQueue As New MessageQueue(path:=".\private$\myQueueAckn")
        Dim ackMsg As Message

        'purge the queues
        queue.Purge()
        ackQueue.Purge()

        'set the admin. queue to which ack. should be set
        msg.AdministrationQueue = ackQueue

        'set the type of ack. we want to receive
        msg.AcknowledgeType = AcknowledgeTypes.FullReceive

        'set a timeout value for the message (10 seconds)
        msg.TimeToBeReceived = New TimeSpan(ticks:=100000000)

        'send the message twice
        msg.Label = "Ack example 1"
        queue.Send(obj:=msg)
        msg.Label = "Ack example 2"
        queue.Send(obj:=msg)

        'receive the 1st message
        Console.WriteLine(queue.Receive().Label)

        'retrieve the positive ack. message
        ackMsg = ackQueue.Receive()

        'write out the ack. information
        Console.WriteLine(value:=ackMsg.Acknowledgment.ToString)

        'retrieve the negative ack. message (timeout)
        ackMsg = ackQueue.Receive()

        'write out the ack. information
        Console.WriteLine(value:=ackMsg.Acknowledgment.ToString)

        'wait to continue
        Console.WriteLine("Enter 's' to stop")
        Do While Not Console.ReadLine = "s" : Loop

    End Sub

End Module
